GNU Radio C++ API Reference: gr::hier_block2 Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::hier_block2 Class Reference
GNU Radio C++ Signal Processing Blocks » Top Block and Hierarchical Block Base Classes | GNU Radio C++ Signal Processing Blocks » Base classes for GR Blocks

Hierarchical container class for gr::block's and gr::hier_block2's. More...

`#include <gnuradio/hier_block2.h>`

## Public Types
typedef basic_block_sptr | opaque_self
| typedef for object returned from self().

## Public Member Functions
| ~hier_block2 () override
opaque_self | self ()
| Return an object, representing the current block, which can be passed to connect.
void | connect (basic_block_sptr block)
| Add a stand-alone (possibly hierarchical) block to internal graph.
void | connect (basic_block_sptr src, int src_port, basic_block_sptr dst, int dst_port)
| Add gr-blocks or hierarchical blocks to internal graph and wire together.
void | msg_connect (basic_block_sptr src, pmt::pmt_t srcport, basic_block_sptr dst, pmt::pmt_t dstport)
| Add gr-blocks or hierarchical blocks to internal graph and wire together.
void | msg_connect (basic_block_sptr src, std::string srcport, basic_block_sptr dst, std::string dstport)
void | msg_disconnect (basic_block_sptr src, pmt::pmt_t srcport, basic_block_sptr dst, pmt::pmt_t dstport)
void | msg_disconnect (basic_block_sptr src, std::string srcport, basic_block_sptr dst, std::string dstport)
void | disconnect (basic_block_sptr block)
| Remove a gr-block or hierarchical block from the internal flowgraph.
void | disconnect (basic_block_sptr src, int src_port, basic_block_sptr dst, int dst_port)
| Disconnect a pair of gr-blocks or hierarchical blocks in internal flowgraph.
void | disconnect_all ()
| Disconnect all connections in the internal flowgraph.
virtual void | lock ()
virtual void | unlock ()
int | max_output_buffer (size_t port=0)
| Returns max buffer size (itemcount) on output port `i`.
void | set_max_output_buffer (int max_output_buffer)
| Sets max buffer size (itemcount) on all output ports.
void | set_max_output_buffer (size_t port, int max_output_buffer)
| Sets max buffer size (itemcount) on output port `port`.
int | min_output_buffer (size_t port=0)
| Returns min buffer size (itemcount) on output port `i`.
void | set_min_output_buffer (int min_output_buffer)
| Sets min buffer size (itemcount) on all output ports.
void | set_min_output_buffer (size_t port, int min_output_buffer)
| Sets min buffer size (itemcount) on output port `port`.
flat_flowgraph_sptr | flatten () const
hier_block2_sptr | to_hier_block2 ()
bool | has_msg_port (pmt::pmt_t which_port) override
bool | message_port_is_hier (pmt::pmt_t port_id) override
bool | message_port_is_hier_in (pmt::pmt_t port_id) override
bool | message_port_is_hier_out (pmt::pmt_t port_id) override
void | message_port_register_hier_in (pmt::pmt_t port_id)
void | message_port_register_hier_out (pmt::pmt_t port_id)
void | set_processor_affinity (const std::vector< int > &mask) override
| Set the affinity of all blocks in hier_block2 to processor core `n`.
void | unset_processor_affinity () override
| Remove processor affinity for all blocks in hier_block2.
std::vector< int > | processor_affinity () override
| Get the current processor affinity.
void | set_log_level (const std::string &level) override
| Set the logger's output level.
std::string | log_level () override
| Get the logger's output level.
bool | all_min_output_buffer_p (void)
| Get if all block min buffers should be set.
bool | all_max_output_buffer_p (void)
| Get if all block max buffers should be set.
Public Member Functions inherited from gr::basic_block
pmt::pmt_t | message_subscribers (pmt::pmt_t port)
| ~basic_block () override
long | unique_id () const
long | symbolic_id () const
std::string | name () const
std::string | symbol_name () const
std::string | identifier () const
gr::io_signature::sptr | input_signature () const
gr::io_signature::sptr | output_signature () const
basic_block_sptr | to_basic_block ()
bool | alias_set () const
std::string | alias () const
pmt::pmt_t | alias_pmt () const
void | set_block_alias (std::string name)
void | message_port_register_in (pmt::pmt_t port_id)
void | message_port_register_out (pmt::pmt_t port_id)
void | message_port_pub (pmt::pmt_t port_id, pmt::pmt_t msg)
void | message_port_sub (pmt::pmt_t port_id, pmt::pmt_t target)
void | message_port_unsub (pmt::pmt_t port_id, pmt::pmt_t target)
pmt::pmt_t | message_ports_in ()
| Get input message port names.
pmt::pmt_t | message_ports_out ()
| Get output message port names.
void | _post (pmt::pmt_t which_port, pmt::pmt_t msg)
bool | empty_p (pmt::pmt_t which_port)
| is the queue empty?
bool | empty_p ()
bool | empty_handled_p (pmt::pmt_t which_port)
| are all msg ports with handlers empty?
bool | empty_handled_p ()
size_t | nmsgs (pmt::pmt_t which_port)
| How many messages in the queue?
void | insert_tail (pmt::pmt_t which_port, pmt::pmt_t msg)
pmt::pmt_t | delete_head_nowait (pmt::pmt_t which_port)
msg_queue_t::iterator | get_iterator (pmt::pmt_t which_port)
void | erase_msg (pmt::pmt_t which_port, msg_queue_t::iterator it)
const msg_queue_map_t & | get_msg_map (void) const
void | add_rpc_variable (rpcbasic_sptr s)
| Add an RPC variable (get or set).
virtual void | setup_rpc ()
| Set up the RPC registered variables.
bool | is_rpc_set ()
| Ask if this block has been registered to the RPC.
void | rpc_set ()
| When the block is registered with the RPC, set this.
virtual bool | check_topology (int ninputs, int noutputs)
| Confirm that ninputs and noutputs is an acceptable combination.
template<typename T>
void | set_msg_handler (pmt::pmt_t which_port, T msg_handler)
| Set the callback that is fired when messages are available.
Public Member Functions inherited from gr::msg_accepter
| msg_accepter ()
| ~msg_accepter () override
void | post (pmt::pmt_t which_port, pmt::pmt_t msg) override
| send `msg` to `msg_accepter` on port `which_port`
Public Member Functions inherited from gr::messages::msg_accepter
| msg_accepter ()

## Public Attributes
pmt::pmt_t | hier_message_ports_in
pmt::pmt_t | hier_message_ports_out

## Protected Member Functions
| hier_block2 ()
| hier_block2 (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
Protected Member Functions inherited from gr::basic_block
| basic_block (void)
| basic_block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
| Protected constructor prevents instantiation by non-derived classes.
void | set_input_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_output_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_color (vcolor color)
| Allow the flowgraph to set for sorting and partitioning.
vcolor | color () const
virtual bool | has_msg_handler (pmt::pmt_t which_port)
| Tests if there is a handler attached to port `which_port`.
virtual void | dispatch_msg (pmt::pmt_t which_port, pmt::pmt_t msg)
template<typename Derived>
std::shared_ptr< Derived > | shared_from_base ()
| This is meant to be called by derived classes (e.g. block) to get a shared pointer internally. This is needed because std::enable_shared_from_this doesn't seem to work with derived classes in an inheritance hierarchy.

## Friends
class | hier_block2_detail

## Additional Inherited Members
Protected Types inherited from gr::basic_block
enum | vcolor { WHITE , GREY , BLACK }
Protected Attributes inherited from gr::basic_block
std::string | d_name
gr::io_signature::sptr | d_input_signature
gr::io_signature::sptr | d_output_signature
long | d_unique_id
long | d_symbolic_id
std::string | d_symbol_name
std::string | d_symbol_alias
vcolor | d_color
bool | d_rpc_set
gr::logger_ptr | d_logger
gr::logger_ptr | d_debug_logger
| Default logger.
msg_queue_map_t | msg_queue
| Verbose logger.
std::vector< rpcbasic_sptr > | d_rpc_vars
pmt::pmt_t | d_message_subscribers

## Detailed Description

Hierarchical container class for gr::block's and gr::hier_block2's.

## Member Typedef Documentation

## ◆ opaque_self

typedef basic_block_sptr gr::hier_block2::opaque_self

typedef for object returned from self().

This type is only guaranteed to be passable to connect and disconnect. No other assumptions should be made about it.

## Constructor & Destructor Documentation

## ◆ hier_block2() [1/2]

gr::hier_block2::hier_block2 | ( |  | ) |
| protected

## ◆ hier_block2() [2/2]

gr::hier_block2::hier_block2 | ( | const std::string & | name,
|  | gr::io_signature::sptr | input_signature,
|  | gr::io_signature::sptr | output_signature )
| protected

References gr::basic_block::input_signature(), gr::basic_block::name(), and gr::basic_block::output_signature().

## ◆ ~hier_block2()

gr::hier_block2::~hier_block2 | ( |  | ) |
| override

## Member Function Documentation

## ◆ all_max_output_buffer_p()

bool gr::hier_block2::all_max_output_buffer_p | ( | void |  | ) |

Get if all block max buffers should be set.

this returns whether all the block max output buffers should be set or just the block ports connected to the hier ports.

## ◆ all_min_output_buffer_p()

bool gr::hier_block2::all_min_output_buffer_p | ( | void |  | ) |

Get if all block min buffers should be set.

this returns whether all the block min output buffers should be set or just the block ports connected to the hier ports.

## ◆ connect() [1/2]

void gr::hier_block2::connect | ( | basic_block_sptr | block | ) |

Add a stand-alone (possibly hierarchical) block to internal graph.

This adds a gr-block or hierarchical block to the internal graph without wiring it to anything else.

## ◆ connect() [2/2]

void gr::hier_block2::connect | ( | basic_block_sptr | src,
|  | int | src_port,
|  | basic_block_sptr | dst,
|  | int | dst_port )

Add gr-blocks or hierarchical blocks to internal graph and wire together.

This adds (if not done earlier by another connect) a pair of gr-blocks or hierarchical blocks to the internal flowgraph, and wires the specified output port to the specified input port.

## ◆ disconnect() [1/2]

void gr::hier_block2::disconnect | ( | basic_block_sptr | block | ) |

Remove a gr-block or hierarchical block from the internal flowgraph.

This removes a gr-block or hierarchical block from the internal flowgraph, disconnecting it from other blocks as needed.

## ◆ disconnect() [2/2]

void gr::hier_block2::disconnect | ( | basic_block_sptr | src,
|  | int | src_port,
|  | basic_block_sptr | dst,
|  | int | dst_port )

Disconnect a pair of gr-blocks or hierarchical blocks in internal flowgraph.

This disconnects the specified input port from the specified output port of a pair of gr-blocks or hierarchical blocks.

## ◆ disconnect_all()

void gr::hier_block2::disconnect_all | ( |  | ) |

Disconnect all connections in the internal flowgraph.

This call removes all output port to input port connections in the internal flowgraph.

## ◆ flatten()

flat_flowgraph_sptr gr::hier_block2::flatten | ( |  | ) | const

## ◆ has_msg_port()

bool gr::hier_block2::has_msg_port | ( | pmt::pmt_t | which_port | ) |
| inlineoverridevirtual

Reimplemented from gr::basic_block.

References gr::basic_block::has_msg_port(), and message_port_is_hier().

## ◆ lock()

virtual void gr::hier_block2::lock | ( |  | ) |
| virtual

Lock a flowgraph in preparation for reconfiguration. When an equal number of calls to lock() and unlock() have occurred, the flowgraph will be reconfigured.

N.B. lock() and unlock() may not be called from a flowgraph thread (E.g., gr::block::work method) or deadlock will occur when reconfiguration happens.

Reimplemented in gr::top_block.

## ◆ log_level()

std::string gr::hier_block2::log_level | ( |  | ) |
| overridevirtual

Get the logger's output level.

Implements gr::basic_block.

## ◆ max_output_buffer()

int gr::hier_block2::max_output_buffer | ( | size_t | port = 0 | ) |

Returns max buffer size (itemcount) on output port `i`.

Referenced by set_max_output_buffer(), and set_max_output_buffer().

## ◆ message_port_is_hier()

bool gr::hier_block2::message_port_is_hier | ( | pmt::pmt_t | port_id | ) |
| inlineoverridevirtual

Reimplemented from gr::basic_block.

References message_port_is_hier_in(), and message_port_is_hier_out().

Referenced by has_msg_port().

## ◆ message_port_is_hier_in()

bool gr::hier_block2::message_port_is_hier_in | ( | pmt::pmt_t | port_id | ) |
| inlineoverridevirtual

Reimplemented from gr::basic_block.

References hier_message_ports_in, and pmt::list_has().

Referenced by message_port_is_hier().

## ◆ message_port_is_hier_out()

bool gr::hier_block2::message_port_is_hier_out | ( | pmt::pmt_t | port_id | ) |
| inlineoverridevirtual

Reimplemented from gr::basic_block.

References hier_message_ports_out, and pmt::list_has().

Referenced by message_port_is_hier().

## ◆ message_port_register_hier_in()

void gr::hier_block2::message_port_register_hier_in | ( | pmt::pmt_t | port_id | ) |
| inline

References hier_message_ports_in, pmt::list_add(), pmt::list_has(), and gr::basic_block::msg_queue.

## ◆ message_port_register_hier_out()

void gr::hier_block2::message_port_register_hier_out | ( | pmt::pmt_t | port_id | ) |
| inline

References gr::basic_block::d_message_subscribers, pmt::dict_has_key(), hier_message_ports_out, pmt::list_add(), and pmt::list_has().

## ◆ min_output_buffer()

int gr::hier_block2::min_output_buffer | ( | size_t | port = 0 | ) |

Returns min buffer size (itemcount) on output port `i`.

Referenced by set_min_output_buffer(), and set_min_output_buffer().

## ◆ msg_connect() [1/2]

void gr::hier_block2::msg_connect | ( | basic_block_sptr | src,
|  | pmt::pmt_t | srcport,
|  | basic_block_sptr | dst,
|  | pmt::pmt_t | dstport )

Add gr-blocks or hierarchical blocks to internal graph and wire together.

This adds (if not done earlier by another connect) a pair of gr-blocks or hierarchical blocks to the internal message port subscription

## ◆ msg_connect() [2/2]

void gr::hier_block2::msg_connect | ( | basic_block_sptr | src,
|  | std::string | srcport,
|  | basic_block_sptr | dst,
|  | std::string | dstport )

## ◆ msg_disconnect() [1/2]

void gr::hier_block2::msg_disconnect | ( | basic_block_sptr | src,
|  | pmt::pmt_t | srcport,
|  | basic_block_sptr | dst,
|  | pmt::pmt_t | dstport )

## ◆ msg_disconnect() [2/2]

void gr::hier_block2::msg_disconnect | ( | basic_block_sptr | src,
|  | std::string | srcport,
|  | basic_block_sptr | dst,
|  | std::string | dstport )

## ◆ processor_affinity()

std::vector< int > gr::hier_block2::processor_affinity | ( |  | ) |
| overridevirtual

Get the current processor affinity.

This returns the processor affinity value for the first block in the hier_block2's list of blocks with the assumption that they have always only been set through the hier_block2's interface. If any block has been individually set, then this call could be misleading.

Implements gr::basic_block.

## ◆ self()

opaque_self gr::hier_block2::self | ( |  | ) |

Return an object, representing the current block, which can be passed to connect.

The returned object may only be used as an argument to connect or disconnect. Any other use of self() results in unspecified (erroneous) behavior.

## ◆ set_log_level()

void gr::hier_block2::set_log_level | ( | const std::string & | level | ) |
| overridevirtual

Set the logger's output level.

Sets the level of the logger for all connected blocks. This takes a string that is translated to the standard levels and can be (case insensitive):

- off , notset
- debug
- info
- notice
- warn
- error
- crit
- alert
- fatal
- emerg

Implements gr::basic_block.

## ◆ set_max_output_buffer() [1/2]

void gr::hier_block2::set_max_output_buffer | ( | int | max_output_buffer | ) |

Sets max buffer size (itemcount) on all output ports.

References max_output_buffer().

## ◆ set_max_output_buffer() [2/2]

void gr::hier_block2::set_max_output_buffer | ( | size_t | port,
|  | int | max_output_buffer )

Sets max buffer size (itemcount) on output port `port`.

References max_output_buffer().

## ◆ set_min_output_buffer() [1/2]

void gr::hier_block2::set_min_output_buffer | ( | int | min_output_buffer | ) |

Sets min buffer size (itemcount) on all output ports.

References min_output_buffer().

## ◆ set_min_output_buffer() [2/2]

void gr::hier_block2::set_min_output_buffer | ( | size_t | port,
|  | int | min_output_buffer )

Sets min buffer size (itemcount) on output port `port`.

References min_output_buffer().

## ◆ set_processor_affinity()

void gr::hier_block2::set_processor_affinity | ( | const std::vector< int > & | mask | ) |
| overridevirtual

Set the affinity of all blocks in hier_block2 to processor core `n`.

Parameters

  mask | a vector of ints of the core numbers available to this block.

Implements gr::basic_block.

## ◆ to_hier_block2()

hier_block2_sptr gr::hier_block2::to_hier_block2 | ( |  | ) |

## ◆ unlock()

virtual void gr::hier_block2::unlock | ( |  | ) |
| virtual

Unlock a flowgraph in preparation for reconfiguration. When an equal number of calls to lock() and unlock() have occurred, the flowgraph will be reconfigured.

N.B. lock() and unlock() may not be called from a flowgraph thread (E.g., gr::block::work method) or deadlock will occur when reconfiguration happens.

Reimplemented in gr::top_block.

## ◆ unset_processor_affinity()

void gr::hier_block2::unset_processor_affinity | ( |  | ) |
| overridevirtual

Remove processor affinity for all blocks in hier_block2.

Implements gr::basic_block.

## Friends And Related Symbol Documentation

## ◆ hier_block2_detail

friend class hier_block2_detail
| friend

References hier_block2_detail.

Referenced by hier_block2_detail.

## Member Data Documentation

## ◆ hier_message_ports_in

pmt::pmt_t gr::hier_block2::hier_message_ports_in

Referenced by message_port_is_hier_in(), and message_port_register_hier_in().

## ◆ hier_message_ports_out

pmt::pmt_t gr::hier_block2::hier_message_ports_out

Referenced by message_port_is_hier_out(), and message_port_register_hier_out().

The documentation for this class was generated from the following file:

- hier_block2.h